
From: William Lee Irwin III <wli@holomorphy.com>

And this one fixes an overflow when there is more than 4GB of hugetlb.



 arch/i386/mm/hugetlbpage.c |    4 +---
 1 files changed, 1 insertion(+), 3 deletions(-)

diff -puN arch/i386/mm/hugetlbpage.c~hugetlb-overflow-fix arch/i386/mm/hugetlbpage.c
--- 25/arch/i386/mm/hugetlbpage.c~hugetlb-overflow-fix	2003-04-17 19:31:03.000000000 -0700
+++ 25-akpm/arch/i386/mm/hugetlbpage.c	2003-04-17 19:31:03.000000000 -0700
@@ -482,9 +482,7 @@ int hugetlb_report_meminfo(char *buf)
 
 int is_hugepage_mem_enough(size_t size)
 {
-	if (size > (htlbpagemem << HPAGE_SHIFT))
-		return 0;
-	return 1;
+	return (size + ~HPAGE_MASK)/HPAGE_SIZE <= htlbpagemem;
 }
 
 /*

_
